/***************************************************************************
                          cmutex.cpp  -  mutex
                             -------------------
    begin                : Sun Sep 30 2001
    copyright            : (C) 2001-2004 by Mathias Kster
    email                : mathen@users.berlios.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cmutex.h"

#include <stdio.h>
#include <string.h>

/** */
CMutex::CMutex()
{
	int i;

	if ( (i=pthread_mutex_init(&mutex,NULL)) == 0 )
	{
		m_bMutexInit = true;
	}
	else
	{
		m_bMutexInit = false;
		
		printf("pthread_mutex_init: %s\n",strerror(i));
	}
}

/** */
CMutex::~CMutex()
{
	int i;

	if ( m_bMutexInit )
	{
		if ( (i=pthread_mutex_destroy(&mutex)) != 0 )
		{
			printf("pthread_mutex_destroy: %s\n",strerror(i));
		}
	}
	
	m_bMutexInit = false;
}

/** */
int CMutex::Lock()
{
	int i = -1;
	
	if ( m_bMutexInit )
	{
		if ( (i=pthread_mutex_lock(&mutex)) != 0 )
		{
			printf("pthread_mutex_lock: %s\n",strerror(i));
		}
	}

	return i;
}

/** */
bool CMutex::TryLock()
{
	if ( m_bMutexInit )
		return ( pthread_mutex_trylock(&mutex) == 0 );
	return false;
}

/** */
int CMutex::UnLock()
{
	int i = -1;

	if ( m_bMutexInit )
	{
		if ( (i=pthread_mutex_unlock(&mutex)) != 0 )
		{
			printf("pthread_mutex_unlock: %s\n",strerror(i));
		}
	}

	return i;
}
