/***************************************************************************
                          cthread.h  -  description
                             -------------------
    begin                : Sun Sep 30 2001
    copyright            : (C) 2001-2004 by Mathias Kster
    email                : mathen@users.berlios.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CTHREAD_H
#define CTHREAD_H

/**
  *@author Mathias Kster
  */

#include <pthread.h>

#include <dclib/dcos.h>
#include <dclib/core/cmutex.h>

class _CCallback0;

class DLL_EXPORT CThread : public CMutex {
public:
	/** */
	CThread();
	/** */
	virtual ~CThread();

	/** */
	int Start();
	/** */
	int Stop( bool bHard = true );
	/** */
	bool Stopped() const;

	/** */
	static void NanoSleep( unsigned long );
	/** */
	void SetThreadCallBackFunction( _CCallback0 * callback );

	/** */
	virtual void Thread() {};


protected:
	/** */
	int iRun;

private:
	/** callback function */
	_CCallback0 * _thread_callback_function;
	/** */
	pthread_t thread;
	/** */
	int iStop;
	/** */
	static void * MainThread(void *object);
};

/** */
inline bool CThread::Stopped() const
{ return (iStop==1); }

#endif
