/***************************************************************************
                           dclib.cpp  -  description
                             -------------------
    begin                : Mon May 5 2003
    copyright            : (C) 2002-2003 by Mathias Kster
    email                : mathen@users.berlios.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dclib.h"

#include "dclib-ssl-use.h"

#include "core/cxml.h"
#include "core/cssl.h"

static time_t sdclibUptime = time(0);
static int sdclibVerbose = 0;

/** initialise used libraries */
extern "C" DLL_EXPORT void dclibInitDepLibs()
{
	CXml::InitParser();
	CSSL::InitSSLLibrary();
}

/** cleanup used libraries */
extern "C" DLL_EXPORT void dclibDeInitDepLibs()
{
	CSSL::DeInitSSLLibrary();
	CXml::CleanupParser();
}

/** get dclib start time */
extern "C" DLL_EXPORT time_t dclibUptime()
{
	return sdclibUptime;
}

/** get dclib version string */
extern "C" DLL_EXPORT const char * dclibVersion()
{
	return DCLIB_VERSION_STRING;
}

/** get dclib build data and if svn, the revision */
extern "C" DLL_EXPORT const char * dclibBuildInfo()
{
	return DCLIB_BUILD_INFO;
}

/** get dclib verbose setting */
extern "C" DLL_EXPORT int dclibVerbose()
{
	return sdclibVerbose;
}

/**  set dclib verbose */
extern "C" DLL_EXPORT void setdclibVerbose( int n )
{
	sdclibVerbose = n;
}

/** get SSL support */
extern "C" DLL_EXPORT bool dclibSupportsSSL()
{
	return (DCLIB_HAS_SSL == 1);
}
