/***************************************************************************
                           dclib.h  -  description
                             -------------------
    begin                : Mon May 5 2003
    copyright            : (C) 2003 by Mathias Kster
    email                : mathen@users.berlios.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DCLIB_H
#define DCLIB_H

/* for DLL_EXPORT define */
#include <dclib/dcos.h>

/**
  *@author Mathias Kster
  */

#include <time.h>

#ifdef __cplusplus
extern "C" {
#endif

/** initialise used libraries */
DLL_EXPORT void dclibInitDepLibs();
/** cleanup used libraries */
DLL_EXPORT void dclibDeInitDepLibs();
/** get dclib start time */
DLL_EXPORT time_t dclibUptime();
/** get dclib version string */
DLL_EXPORT const char * dclibVersion();
/** get dclib build date and if svn, the revision */
DLL_EXPORT const char * dclibBuildInfo();
/** get dclib verbose setting */
DLL_EXPORT int dclibVerbose();
/**  set dclib verbose */
DLL_EXPORT void setdclibVerbose( int n );
/** get SSL support */
DLL_EXPORT bool dclibSupportsSSL();

#ifdef WIN32
#define DPRINTF
#else
#define DPRINTF if (dclibVerbose()) printf
#endif
#ifdef __cplusplus
}
#endif

#endif
