/***************************************************************************
        tth-test.cpp  -  Test the case folder works (in UTF-8 locale)
                             -------------------
    begin                : Thu Sep 11 2008
    copyright            : (C) 2008 by Edward Sheldrake
    email                : ejs1920@yahoo.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <dclib/ccasefolder.h>

#include <stdio.h>

int main( int, char*[] )
{
	/* without CConfig CCaseFolder uses UTF-8 */
	CCaseFolder folder;
	
	/* a few vowels from what gucharmap calls the Latin-1 Supplement*/
	CString input = "ABCDEF ÁÉÌÓÙ áéìóù UVWXYZ";
	CString expected = "abcdef áéìóù áéìóù uvwxyz";
	CString output;
	
	if ( folder.Fold( input, output ) )
	{
		if ( output == expected )
		{
			return 0;
		}
		else
		{
			printf("case-fold: input='%s' expected='%s' got='%s'\n", input.Data(), expected.Data(), output.Data());
			return 1;
		}
	}
	else
	{
		printf("case-fold: folding failed, iconv problem?\n");
		return 2;
	}
}
